# Copyright Vespa.ai. Licensed under the terms of the Apache 2.0 license. See LICENSE in the project root.

# This file contains some of the vespa cmake config needed for other
# cmake projects depending on vespa.

set(VESPA_VERSION 8.363.17)

####### Expanded from @PACKAGE_INIT@ by configure_package_config_file() #######
####### Any changes to this file will be overwritten by the next CMake run ####
####### The input file was vespaConfig.cmake.in                            ########

get_filename_component(PACKAGE_PREFIX_DIR "${CMAKE_CURRENT_LIST_DIR}/../../../" ABSOLUTE)

macro(set_and_check _var _file)
  set(${_var} "${_file}")
  if(NOT EXISTS "${_file}")
    message(FATAL_ERROR "File or directory ${_file} referenced by variable ${_var} does not exist !")
  endif()
endmacro()

macro(check_required_components _NAME)
  foreach(comp ${${_NAME}_FIND_COMPONENTS})
    if(NOT ${_NAME}_${comp}_FOUND)
      if(${_NAME}_FIND_REQUIRED_${comp})
        set(${_NAME}_FOUND FALSE)
      endif()
    endif()
  endforeach()
endmacro()

####################################################################################
set_and_check(VESPA_INCLUDE_DIR "${PACKAGE_PREFIX_DIR}/include")
set_and_check(VESPA_HOME "${PACKAGE_PREFIX_DIR}")
set_and_check(VESPA_CMAKECONFIG_DIR "${PACKAGE_PREFIX_DIR}/share/cmake/vespa")
include("${CMAKE_CURRENT_LIST_DIR}/vespaTargets.cmake")
check_required_components(vespa)
message(STATUS "Found vespa ${VESPA_VERSION} at ${VESPA_HOME}")
